from bridges.data_src_dependent import data_source
from bridges.bridges import Bridges
import os
import queue as Q
    
#return the vertex the closest to some lat/lon coordinate
def getClosest(gr, lat, lon):
    # TODO
    
    return -1

#styling the source vertex
def style_root(gr, root) :
    # TODO
    
#shortest path function
def dijkstra (gr, root) :
    distance = {}
    parent = {}
    
    for v in gr.vertices:
        distance[v] = float('inf')

    distance[root] = 0

    qu = Q.PriorityQueue()
    qu.put((distance[root], root))
    
    while not qu.empty():
        (d,v) = qu.get()
        if d > distance[v]: #because we use a heap and not a fibonacci heap, the same vertex could show up multiple times.
            continue

        nei_link = gr.get_adjacency_list(v)
        while (nei_link != None): #for all neighboors
            nei=nei_link.get_value().get_vertex()
            edge_length=nei_link.get_value().get_weight()

            #Relax the edge
            if distance[v]+edge_length < distance[nei]:
                #new SP found
                distance[nei] = distance[v]+edge_length
                qu.put((distance[nei], nei))
                          
            nei_link=nei_link.get_next()
            
    return distance
    
#style the graph based on distance
def style_distance(gr, distance):
    #TODO
    #find the maximum distance which is not infinity

    #style the color of vertices with a linear scale

    
#style the path between the root and the destination (root is not given because all parent path goes to root)
def style_parent(gr, parent, dest):
    #TODO
    
    # style all vertices to almost invisible

    # style all edges to almost invisible

    # Style the path between parent and dest in black
    ##style node

    ##style edge along the path
         
def main():
    user = "BRIDGES_USER_NAME"
    key = "BRIDGES_API_KEY"

    #get data
    bridges = Bridges(100, user, key)
    bridges.connector.set_server("clone")

    #TODO: Get Data
    

    #TODO: Uncomment for part 2
    # #find and style the root of the Shortest Path
    # root = getClosest(gr,
    #                      (osm_data.latitude_range[0]+osm_data.latitude_range[1])/2,
    #                      (osm_data.longitude_range[0]+osm_data.longitude_range[1])/2)
    # style_root(gr, root)
    # bridges.set_data_structure(gr)
    # bridges.visualize()

    #TODO: Uncomment for part 3
    # #run Shortest Path
    # distance = dijkstra(gr,root)
    # #(distance,parent) = dijkstra(gr,root)

    # #style vertices based on distances
    # style_distance(gr, distance)
    # bridges.set_data_structure(gr)
    # bridges.visualize()

    #TODO Uncomment for part 4
    # #find a destination
    # dest = getClosest(gr,
    #                   (osm_data.latitude_range[0]+(osm_data.latitude_range[1]-osm_data.latitude_range[0])/4),
    #                   (osm_data.longitude_range[0]+(osm_data.longitude_range[1]-osm_data.longitude_range[0])/4))

    # #style the path from root to destination
    # style_parent(gr,parent, dest)

    # bridges.set_data_structure(gr)
    # bridges.visualize()


if __name__ == "__main__":
    main()
